/**
 * Created by Author on 2018/8/20.
 */
var BucketName = '';
var accessKeyId = '';
var secretAccessKey = '';
var endPoint = '';
// 分片上传 initial
var initialId = '';
// 分片上传 complete 所需参数
var MultipartUpload = {
	Parts: []
};

var client;
function config() {

	endPoint = document.getElementById('endpoint').value;
	BucketName = document.getElementById('bucket').value;
	accessKeyId = document.getElementById('ak').value;
	secretAccessKey = document.getElementById('sk').value;

	client = new OOS.S3({
		accessKeyId: accessKeyId,
		secretAccessKey: secretAccessKey,
		endpoint: endPoint,
		signatureVersion: 'v4', // 可选v2 或v4
		apiVersion: '2006-03-01',
		s3ForcePathStyle: true
	});

}
function get_bucket_acl() {
	var params = {
		Bucket: BucketName
	};
	client.getBucketAcl(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function get_bucket() {
	var params = {
		Bucket: BucketName
	};
	client.listObjects(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function get_bucket_location() {
	var params = {
		Bucket: BucketName
	};
	client.getBucketLocation(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function del_bucket() {
	var Bucket = document.getElementById('delBucketName').value;
	var params = {
		Bucket: Bucket
	};
	client.deleteBucket(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function put_bucket_policy() {
	var Policy = document.getElementById('policy').value;
	var params = {
		Bucket: BucketName,
		Policy: Policy
	};
	client.putBucketPolicy(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function get_bucket_policy() {
	var params = {
		Bucket: BucketName

	};
	client.getBucketPolicy(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function del_bucket_policy() {
	var params = {
		Bucket: BucketName,

	};
	client.deleteBucketPolicy(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function put_bucket_website() {
	var Suffix = document.getElementById('suffix').value;
	var Key = document.getElementById('key').value;
	var params = {
		Bucket: BucketName,
		WebsiteConfiguration: {
			ErrorDocument: {
				Key: Key
			},
			IndexDocument: {
				Suffix: Suffix
			}
		}
	};
	client.putBucketWebsite(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function get_bucket_website() {
	var params = {
		Bucket: BucketName

	};
	client.getBucketWebsite(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function del_bucket_website() {
	var params = {
		Bucket: BucketName

	};
	client.deleteBucketWebsite(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function list_multipart_uploads() {
	var params = {
		Bucket: BucketName
	};
	client.listMultipartUploads(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function put_bucket_logging() {
	var params = {
		Bucket: BucketName,
		BucketLoggingStatus: {}
	};
	client.putBucketLogging(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}

function get_bucket_logging() {
	var params = {
		Bucket: BucketName
	};
	client.getBucketLogging(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function head_bucket() {
	var params = {
		Bucket: BucketName
	};
	client.headBucket(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function put_bucket_lifecycle_configuration() {
	var ExpirationDays = document.getElementById('ExpirationDays').value;
	var FilterPrefix = document.getElementById('FilterPrefix').value;
	var ID = document.getElementById('ID').value;
	var Status = document.getElementById('Status').value;
	var params = {
		Bucket: BucketName,
		LifecycleConfiguration: {
			Rules: [
				{
					Expiration: {
						Days: ExpirationDays
					},
					Filter: {
						Prefix: FilterPrefix
					},
					ID: ID,
					Status: Status
				}
			]
		}
	};
	client.putBucketLifecycleConfiguration(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function get_bucket_lifecycle_configuration() {
	var params = {
		Bucket: BucketName
	};
	client.getBucketLifecycleConfiguration(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function del_bucket_lifecycle_configuration() {
	var params = {
		Bucket: BucketName
	};
	client.deleteBucketLifecycle(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function put_bucket_accelerate_configuration() {
	var IP1 = document.getElementById('IP1').value;
	var IP2 = document.getElementById('IP2').value;
	var Status = document.getElementById('StatusAccelerate').value;
	var params = {
		Bucket: BucketName,
		AccelerateConfiguration: {
			Status: Status,
			IPWhiteLists: {
				IP: [IP1, IP2]
			}

		}
	};
	client.putBucketAccelerateConfiguration(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function get_bucket_accelerate_configuration() {
	var params = {
		Bucket: BucketName
	};
	client.getBucketAccelerateConfiguration(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
/*
 * Object Operation
 * */
function put_object() {
	var file = document.getElementById('file').files[0];
	var key = file.name;
	var params = {
		Body: file,
		Bucket: BucketName,
		Key: key
	};
	client.putObject(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}

function get_object() {
	var getKeyName = document.getElementById('getKeyName').value;
	var params = {
		Bucket: BucketName,
		Key: getKeyName
	};
	client.getObject(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function del_object() {
	var delKeyName = document.getElementById('delKeyName').value;
	var params = {
		Bucket: BucketName,
		Key: delKeyName
	};
	client.deleteObject(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function copy_object() {
	var CopyKey = document.getElementById('CopyKey').value;
	var CopySourceBucket = document.getElementById('CopySourceBucket').value;
	var CopySourceName = document.getElementById('CopySourceName').value;
	var params = {
		Bucket: BucketName,
		Key: CopyKey,
		CopySource: '/' + CopySourceBucket + '/' + encodeURIComponent(CopySourceName)
	};
	client.copyObject(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function initial_multipart_upload() {
	var largeName = document.getElementById('largeName').value;
	var params = {
		Bucket: BucketName,
		Key: largeName
	};
	client.createMultipartUpload(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurredw
		else     console.log(data);           // successful response
		initialId = data.UploadId;
	});
}
function upload_part() {
	var largeName = document.getElementById('uploadLargeName').value;
	var UploadId = document.getElementById('initialId').value;
	var PartNumber = document.getElementById('PartNumber').value;
	var file = document.getElementById('part_file').files[0];
	var params = {
		Body: file,
		Bucket: BucketName,
		Key: largeName,
		PartNumber: PartNumber,
		UploadId: UploadId
	};
	client.uploadPart(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else {
			MultipartUpload.Parts.push({PartNumber: PartNumber, ETag: data.ETag})
		}
		;           // successful response
	});
}
function complete_multipart_upload() {
	var largeName = document.getElementById('comLargeName').value;
	var initialId = document.getElementById('comInitialId').value;
	var params = {
		Bucket: BucketName,
		Key: largeName,
		UploadId: initialId,
		MultipartUpload: MultipartUpload
	};
	client.completeMultipartUpload(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function abort_multipart_upload() {
	var largeName = document.getElementById('aboLargeName').value;
	var initialId = document.getElementById('aboInitialId').value;
	var params = {
		Bucket: BucketName,
		Key: largeName,
		UploadId: initialId
	};
	client.abortMultipartUpload(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function list_parts() {
	var largeName = document.getElementById('listLargeName').value;
	var initialId = document.getElementById('listInitialId').value;
	var params = {
		Bucket: BucketName,
		Key: largeName,
		UploadId: initialId
	};

	client.listParts(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function copy_part() {
	var PartNumber = document.getElementById('CopyPartNumber').value;
	var CopySourceBucket = document.getElementById('uploadCopySourceBucket').value;
	var CopySourceName = document.getElementById('uploadCopySourceName').value;
	var initialId = document.getElementById('CopyInitialId').value;
	var copyLargeName = document.getElementById('copyLargeName').value;
	var params = {
		Bucket: BucketName,
		Key: copyLargeName,
		CopySource: '/' + CopySourceBucket + '/' + encodeURIComponent(CopySourceName),
		PartNumber: PartNumber,
		UploadId: initialId
	};

	client.uploadPartCopy(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function del_objects() {
	var str = document.getElementById('deleteObjects').value;
	var objs = [];
	str.split(',').map(function (item) {
		var tempObj = {Key: item};
		objs.push(tempObj)
	})
	var params = {
		Bucket: BucketName,
		Delete: {
			Objects: objs,
			Quiet: true
		}
	};
	client.deleteObjects(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}
function pre_sign() {
	var KeyName = document.getElementById('preKey').value;
	var params = {
		Bucket: BucketName,
		Key: KeyName
	};
	var url = client.getSignedUrl('getObject', params);
	console.log(url)
}

function head_object() {
	var getKeyName = document.getElementById('headKeyName').value;
	var params = {
		Bucket: BucketName,
		Key: getKeyName
	};
	client.headObject(params, function (err, data) {
		if (err) console.log(err, err.stack); // an error occurred
		else     console.log(data);           // successful response
	});
}